=== lib/CMakeLists.txt ===
add_main_lib(vcmi SHARED)
