=== debian/changelog ===
vcmi (1.1.0+dfsg-1) unstable; urgency=medium

  * new upstream release
  * drop debian/patches/enable_gitversion_off
  * debian/patches/disable-privacy-breach: refresh
  * debian/rules: do not rm ./Mods/vcmi/Maps/VCMI_Tests_2011b.h3m because it's
    in Files-Excluded

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Wed, 01 Feb 2023 14:35:51 +0100

vcmi (1.0.0+dfsg-4) unstable; urgency=medium

  * remove /usr/share/vcmi/Mods/vcmi/Maps/VCMI_Tests_2011b.h3m as it conflicts
    with the .deb built by game-data-packager (closes: #1020287)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Tue, 27 Sep 2022 14:58:41 +0200

vcmi (1.0.0+dfsg-3) unstable; urgency=medium

  [ Stephen Kitt ]
  * Revert to “Architecture: any”, we’ll rely on build-dependency
    availability to determine the architectures on which the package is
    available.

  [ Johannes Schauer Marin Rodrigues ]

  * debian/patches/disable-privacy-breach: also disable updateOnStartup
  * debian/rules: build with ENABLE_GITVERSION=OFF
  * add patch fixing https://github.com/vcmi/vcmi/issues/883

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Tue, 27 Sep 2022 09:35:58 +0200

vcmi (1.0.0+dfsg-2) unstable; urgency=medium

  * debian/control: temporarily limit architectures to all release arches
    except ppc64el because luajit doesn't work on ppc64el (see #1014853)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Mon, 19 Sep 2022 19:12:50 +0200

vcmi (1.0.0+dfsg-1) unstable; urgency=medium

  * new upstream release
  * debian/patches/disable-privacy-breach: refresh
  * remove the date from manual to make it reproducible

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Mon, 12 Sep 2022 11:48:26 +0200
